diff -ruN vdr-1.7.24/PLUGINS/src/rcu/rcu.c vdr-1.7.25/PLUGINS/src/rcu/rcu.c
--- vdr-1.7.24/PLUGINS/src/rcu/rcu.c	1970-01-01 01:00:00.000000000 +0100
+++ vdr-1.7.25/PLUGINS/src/rcu/rcu.c	2012-02-27 12:49:51.000000000 +0100
@@ -0,0 +1,420 @@
+/*
+ * rcu.c: A plugin for the Video Disk Recorder
+ *
+ * See the README file for copyright information and how to reach the author.
+ *
+ * $Id: rcu.c 1.1 2012/02/27 11:49:51 kls Exp $
+ */
+
+#include <getopt.h>
+#include <netinet/in.h>
+#include <termios.h>
+#include <unistd.h>
+#include <vdr/plugin.h>
+#include <vdr/remote.h>
+#include <vdr/status.h>
+#include <vdr/thread.h>
+#include <vdr/tools.h>
+
+static const char *VERSION        = "0.0.1";
+static const char *DESCRIPTION    = "Remote Control Unit";
+
+#define REPEATLIMIT      150 // ms
+#define REPEATDELAY      350 // ms
+#define HANDSHAKETIMEOUT  20 // ms
+#define DEFAULTDEVICE    "/dev/ttyS1"
+
+class cRcuRemote : public cRemote, private cThread, private cStatus {
+private:
+  enum { modeH = 'h', modeB = 'b', modeS = 's' };
+  int f;
+  unsigned char dp, code, mode;
+  int number;
+  unsigned int data;
+  bool receivedCommand;
+  bool SendCommand(unsigned char Cmd);
+  int ReceiveByte(int TimeoutMs = 0);
+  bool SendByteHandshake(unsigned char c);
+  bool SendByte(unsigned char c);
+  bool SendData(unsigned int n);
+  void SetCode(unsigned char Code);
+  void SetMode(unsigned char Mode);
+  void SetNumber(int n, bool Hex = false);
+  void SetPoints(unsigned char Dp, bool On);
+  void SetString(const char *s);
+  bool DetectCode(unsigned char *Code);
+  virtual void Action(void);
+  virtual void ChannelSwitch(const cDevice *Device, int ChannelNumber);
+  virtual void Recording(const cDevice *Device, const char *Name, const char *FileName, bool On);
+public:
+  cRcuRemote(const char *DeviceName);
+  virtual ~cRcuRemote();
+  virtual bool Ready(void);
+  virtual bool Initialize(void);
+  };
+
+cRcuRemote::cRcuRemote(const char *DeviceName)
+:cRemote("RCU")
+,cThread("RCU remote control")
+{
+  dp = 0;
+  mode = modeB;
+  code = 0;
+  number = 0;
+  data = 0;
+  receivedCommand = false;
+  if ((f = open(DeviceName, O_RDWR | O_NONBLOCK)) >= 0) {
+     struct termios t;
+     if (tcgetattr(f, &t) == 0) {
+        cfsetspeed(&t, B9600);
+        cfmakeraw(&t);
+        if (tcsetattr(f, TCSAFLUSH, &t) == 0) {
+           SetNumber(8888);
+           const char *Setup = GetSetup();
+           if (Setup) {
+              code = *Setup;
+              SetCode(code);
+              isyslog("connecting to %s remote control using code %c", Name(), code);
+              }
+           Start();
+           return;
+           }
+        }
+     LOG_ERROR_STR(DeviceName);
+     close(f);
+     }
+  else
+     LOG_ERROR_STR(DeviceName);
+  f = -1;
+}
+
+cRcuRemote::~cRcuRemote()
+{
+  Cancel();
+}
+
+bool cRcuRemote::Ready(void)
+{
+  return f >= 0;
+}
+
+bool cRcuRemote::Initialize(void)
+{
+  if (f >= 0) {
+     unsigned char Code = '0';
+     isyslog("trying codes for %s remote control...", Name());
+     for (;;) {
+         if (DetectCode(&Code)) {
+            code = Code;
+            break;
+            }
+         }
+     isyslog("established connection to %s remote control using code %c", Name(), code);
+     char buffer[16];
+     snprintf(buffer, sizeof(buffer), "%c", code);
+     PutSetup(buffer);
+     return true;
+     }
+  return false;
+}
+
+void cRcuRemote::Action(void)
+{
+#pragma pack(1)
+  union {
+    struct {
+      unsigned short address;
+      unsigned int command;
+      } data;
+    unsigned char raw[6];
+    } buffer;
+#pragma pack()
+
+  time_t LastCodeRefresh = 0;
+  cTimeMs FirstTime;
+  unsigned char LastCode = 0, LastMode = 0;
+  uint64_t LastCommand = ~0; // 0x00 might be a valid command
+  unsigned int LastData = 0;
+  bool repeat = false;
+
+  while (Running() && f >= 0) {
+        if (ReceiveByte(REPEATLIMIT) == 'X') {
+           for (int i = 0; i < 6; i++) {
+               int b = ReceiveByte();
+               if (b >= 0) {
+                  buffer.raw[i] = b;
+                  if (i == 5) {
+                     unsigned short Address = ntohs(buffer.data.address); // the PIC sends bytes in "network order"
+                     uint64_t       Command = ntohl(buffer.data.command);
+                     if (code == 'B' && Address == 0x0000 && Command == 0x00004000)
+                        // Well, well, if it isn't the "d-box"...
+                        // This remote control sends the above command before and after
+                        // each keypress - let's just drop this:
+                        break;
+                     Command |= uint64_t(Address) << 32;
+                     if (Command != LastCommand) {
+                        LastCommand = Command;
+                        repeat = false;
+                        FirstTime.Set();
+                        }
+                     else {
+                        if (FirstTime.Elapsed() < REPEATDELAY)
+                           break; // repeat function kicks in after a short delay
+                        repeat = true;
+                        }
+                     Put(Command, repeat);
+                     receivedCommand = true;
+                     }
+                  }
+               else
+                  break;
+               }
+           }
+        else if (repeat) { // the last one was a repeat, so let's generate a release
+           Put(LastCommand, false, true);
+           repeat = false;
+           LastCommand = ~0;
+           }
+        else {
+           unsigned int d = data;
+           if (d != LastData) {
+              SendData(d);
+              LastData = d;
+              }
+           unsigned char c = code;
+           if (c != LastCode) {
+              SendCommand(c);
+              LastCode = c;
+              }
+           unsigned char m = mode;
+           if (m != LastMode) {
+              SendCommand(m);
+              LastMode = m;
+              }
+           LastCommand = ~0;
+           }
+        if (!repeat && code && time(NULL) - LastCodeRefresh > 60) {
+           SendCommand(code); // in case the PIC listens to the wrong code
+           LastCodeRefresh = time(NULL);
+           }
+        }
+}
+
+int cRcuRemote::ReceiveByte(int TimeoutMs)
+{
+  // Returns the byte if one was received within a timeout, -1 otherwise
+  if (cFile::FileReady(f, TimeoutMs)) {
+     unsigned char b;
+     if (safe_read(f, &b, 1) == 1)
+        return b;
+     else
+        LOG_ERROR;
+     }
+  return -1;
+}
+
+bool cRcuRemote::SendByteHandshake(unsigned char c)
+{
+  if (f >= 0) {
+     int w = write(f, &c, 1);
+     if (w == 1) {
+        for (int reply = ReceiveByte(HANDSHAKETIMEOUT); reply >= 0;) {
+            if (reply == c)
+               return true;
+            else if (reply == 'X') {
+               // skip any incoming RC code - it will come again
+               for (int i = 6; i--;) {
+                   if (ReceiveByte() < 0)
+                      return false;
+                   }
+               }
+            else
+               return false;
+            }
+        }
+     LOG_ERROR;
+     }
+  return false;
+}
+
+bool cRcuRemote::SendByte(unsigned char c)
+{
+  for (int retry = 5; retry--;) {
+      if (SendByteHandshake(c))
+         return true;
+      }
+  return false;
+}
+
+bool cRcuRemote::SendData(unsigned int n)
+{
+  for (int i = 0; i < 4; i++) {
+      if (!SendByte(n & 0x7F))
+         return false;
+      n >>= 8;
+      }
+  return SendCommand(mode);
+}
+
+void cRcuRemote::SetCode(unsigned char Code)
+{
+  code = Code;
+}
+
+void cRcuRemote::SetMode(unsigned char Mode)
+{
+  mode = Mode;
+}
+
+bool cRcuRemote::SendCommand(unsigned char Cmd)
+{
+  return SendByte(Cmd | 0x80);
+}
+
+void cRcuRemote::SetNumber(int n, bool Hex)
+{
+  number = n;
+  if (!Hex) {
+     char buf[8];
+     sprintf(buf, "%4d", n & 0xFFFF);
+     n = 0;
+     for (char *d = buf; *d; d++) {
+         if (*d == ' ')
+            *d = 0xF;
+         n = (n << 4) | ((*d - '0') & 0x0F);
+         }
+     }
+  unsigned int m = 0;
+  for (int i = 0; i < 4; i++) {
+      m <<= 8;
+      m |= ((i & 0x03) << 5) | (n & 0x0F) | (((dp >> i) & 0x01) << 4);
+      n >>= 4;
+      }
+  data = m;
+}
+
+void cRcuRemote::SetString(const char *s)
+{
+  const char *chars = mode == modeH ? "0123456789ABCDEF" : "0123456789-EHLP ";
+  int n = 0;
+
+  for (int i = 0; *s && i < 4; s++, i++) {
+      n <<= 4;
+      for (const char *c = chars; *c; c++) {
+          if (*c == *s) {
+             n |= c - chars;
+             break;
+             }
+          }
+      }
+  SetNumber(n, true);
+}
+
+void cRcuRemote::SetPoints(unsigned char Dp, bool On)
+{
+  if (On)
+     dp |= Dp;
+  else
+     dp &= ~Dp;
+  SetNumber(number);
+}
+
+bool cRcuRemote::DetectCode(unsigned char *Code)
+{
+  // Caller should initialize 'Code' to 0 and call DetectCode()
+  // until it returns true. Whenever DetectCode() returns false
+  // and 'Code' is not 0, the caller can use 'Code' to display
+  // a message like "Trying code '%c'". If false is returned and
+  // 'Code' is 0, all possible codes have been tried and the caller
+  // can either stop calling DetectCode() (and give some error
+  // message), or start all over again.
+  if (*Code < 'A' || *Code > 'D') {
+     *Code = 'A';
+     return false;
+     }
+  if (*Code <= 'D') {
+     SetMode(modeH);
+     char buf[5];
+     sprintf(buf, "C0D%c", *Code);
+     SetString(buf);
+     SetCode(*Code);
+     cCondWait::SleepMs(2 * REPEATDELAY);
+     if (receivedCommand) {
+        SetMode(modeB);
+        SetString("----");
+        return true;
+        }
+     if (*Code < 'D') {
+        (*Code)++;
+        return false;
+        }
+     }
+  *Code = 0;
+  return false;
+}
+
+void cRcuRemote::ChannelSwitch(const cDevice *Device, int ChannelNumber)
+{
+  if (ChannelNumber && Device->IsPrimaryDevice())
+     SetNumber(cDevice::CurrentChannel());
+}
+
+void cRcuRemote::Recording(const cDevice *Device, const char *Name, const char *FileName, bool On)
+{
+  SetPoints(1 << Device->DeviceNumber(), Device->Receiving());
+}
+
+class cPluginRcu : public cPlugin {
+private:
+  // Add any member variables or functions you may need here.
+  const char *device;
+public:
+  cPluginRcu(void);
+  virtual const char *Version(void) { return VERSION; }
+  virtual const char *Description(void) { return DESCRIPTION; }
+  virtual const char *CommandLineHelp(void);
+  virtual bool ProcessArgs(int argc, char *argv[]);
+  virtual bool Start(void);
+  };
+
+cPluginRcu::cPluginRcu(void)
+{
+  // Initialize any member variables here.
+  // DON'T DO ANYTHING ELSE THAT MAY HAVE SIDE EFFECTS, REQUIRE GLOBAL
+  // VDR OBJECTS TO EXIST OR PRODUCE ANY OUTPUT!
+  device = DEFAULTDEVICE;
+}
+
+const char *cPluginRcu::CommandLineHelp(void)
+{
+  // Return a string that describes all known command line options.
+  return "  -d DEV,   --device=DEV   set the device to use (default is " DEFAULTDEVICE ")\n";
+}
+
+bool cPluginRcu::ProcessArgs(int argc, char *argv[])
+{
+  // Implement command line argument processing here if applicable.
+  static struct option long_options[] = {
+       { "dev",      required_argument, NULL, 'd' },
+       { NULL,       no_argument,       NULL,  0  }
+     };
+
+  int c;
+  while ((c = getopt_long(argc, argv, "d:", long_options, NULL)) != -1) {
+        switch (c) {
+          case 'd': device = optarg;
+                    break;
+          default:  return false;
+          }
+        }
+  return true;
+}
+
+bool cPluginRcu::Start(void)
+{
+  // Start any background activities the plugin shall perform.
+  new cRcuRemote(device);
+  return true;
+}
+
+VDRPLUGINCREATOR(cPluginRcu); // Don't touch this!
diff -ruN vdr-1.7.24/ci.c vdr-1.7.25/ci.c
--- vdr-1.7.24/ci.c	2011-05-21 17:21:33.000000000 +0200
+++ vdr-1.7.25/ci.c	2012-02-29 11:24:41.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: ci.c 2.7 2011/05/21 15:21:33 kls Exp $
+ * $Id: ci.c 2.8 2012/02/29 10:24:41 kls Exp $
  */
 
 #include "ci.h"
@@ -1841,7 +1841,7 @@
 int cCamSlot::Priority(void)
 {
   cDevice *d = Device();
-  return d ? d->Priority() : -1;
+  return d ? d->Priority() : IDLEPRIORITY;
 }
 
 bool cCamSlot::ProvidesCa(const int *CaSystemIds)
diff -ruN vdr-1.7.24/ci.h vdr-1.7.25/ci.h
--- vdr-1.7.24/ci.h	2011-12-04 14:38:17.000000000 +0100
+++ vdr-1.7.25/ci.h	2012-02-29 11:24:27.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: ci.h 2.1 2011/12/04 13:38:17 kls Exp $
+ * $Id: ci.h 2.2 2012/02/29 10:24:27 kls Exp $
  */
 
 #ifndef __CI_H
@@ -192,7 +192,7 @@
        ///< Gets a pending enquiry, or NULL if there is no enquiry.
   int Priority(void);
        ///< Returns the priority if the device this slot is currently assigned
-       ///< to, or -1 if it is not assigned to any device.
+       ///< to, or IDLEPRIORITY if it is not assigned to any device.
   bool ProvidesCa(const int *CaSystemIds);
        ///< Returns true if the CAM in this slot provides one of the given
        ///< CaSystemIds. This doesn't necessarily mean that it will be
diff -ruN vdr-1.7.24/config.c vdr-1.7.25/config.c
--- vdr-1.7.24/config.c	2012-01-14 14:04:59.000000000 +0100
+++ vdr-1.7.25/config.c	2012-02-29 11:15:54.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: config.c 2.18 2012/01/14 13:04:59 kls Exp $
+ * $Id: config.c 2.20 2012/02/29 10:15:54 kls Exp $
  */
 
 #include "config.h"
@@ -406,9 +406,8 @@
   SVDRPTimeout = 300;
   ZapTimeout = 3;
   ChannelEntryTimeout = 1000;
-  PrimaryLimit = 0;
   DefaultPriority = 50;
-  DefaultLifetime = 99;
+  DefaultLifetime = MAXLIFETIME;
   PauseKeyHandling = 2;
   PausePriority = 10;
   PauseLifetime = 1;
@@ -601,7 +600,6 @@
   else if (!strcasecmp(Name, "SVDRPTimeout"))        SVDRPTimeout       = atoi(Value);
   else if (!strcasecmp(Name, "ZapTimeout"))          ZapTimeout         = atoi(Value);
   else if (!strcasecmp(Name, "ChannelEntryTimeout")) ChannelEntryTimeout= atoi(Value);
-  else if (!strcasecmp(Name, "PrimaryLimit"))        PrimaryLimit       = atoi(Value);
   else if (!strcasecmp(Name, "DefaultPriority"))     DefaultPriority    = atoi(Value);
   else if (!strcasecmp(Name, "DefaultLifetime"))     DefaultLifetime    = atoi(Value);
   else if (!strcasecmp(Name, "PauseKeyHandling"))    PauseKeyHandling   = atoi(Value);
@@ -699,7 +697,6 @@
   Store("SVDRPTimeout",       SVDRPTimeout);
   Store("ZapTimeout",         ZapTimeout);
   Store("ChannelEntryTimeout",ChannelEntryTimeout);
-  Store("PrimaryLimit",       PrimaryLimit);
   Store("DefaultPriority",    DefaultPriority);
   Store("DefaultLifetime",    DefaultLifetime);
   Store("PauseKeyHandling",   PauseKeyHandling);
diff -ruN vdr-1.7.24/config.h vdr-1.7.25/config.h
--- vdr-1.7.24/config.h	2012-01-16 10:50:03.000000000 +0100
+++ vdr-1.7.25/config.h	2012-02-29 13:28:01.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: config.h 2.40 2012/01/16 09:50:03 kls Exp $
+ * $Id: config.h 2.43 2012/02/29 12:28:01 kls Exp $
  */
 
 #ifndef __CONFIG_H
@@ -22,13 +22,13 @@
 
 // VDR's own version number:
 
-#define VDRVERSION  "1.7.24"
-#define VDRVERSNUM   10724  // Version * 10000 + Major * 100 + Minor
+#define VDRVERSION  "1.7.25"
+#define VDRVERSNUM   10725  // Version * 10000 + Major * 100 + Minor
 
 // The plugin API's version number:
 
-#define APIVERSION  "1.7.24"
-#define APIVERSNUM   10724  // Version * 10000 + Major * 100 + Minor
+#define APIVERSION  "1.7.25"
+#define APIVERSNUM   10725  // Version * 10000 + Major * 100 + Minor
 
 // When loading plugins, VDR searches them by their APIVERSION, which
 // may be smaller than VDRVERSION in case there have been no changes to
@@ -36,8 +36,12 @@
 // plugins to work with newer versions of the core VDR as long as no
 // VDR header files have changed.
 
-#define MAXPRIORITY 99
-#define MAXLIFETIME 99
+#define MAXPRIORITY       99
+#define MINPRIORITY       (-MAXPRIORITY)
+#define LIVEPRIORITY      0                  // priority used when selecting a device for live viewing
+#define TRANSFERPRIORITY  (LIVEPRIORITY - 1) // priority used for actual local Transfer Mode
+#define IDLEPRIORITY      (MINPRIORITY - 1)  // priority of an idle device
+#define MAXLIFETIME       99
 
 #define MINOSDWIDTH   480
 #define MAXOSDWIDTH  1920
@@ -264,7 +268,6 @@
   int SVDRPTimeout;
   int ZapTimeout;
   int ChannelEntryTimeout;
-  int PrimaryLimit;
   int DefaultPriority, DefaultLifetime;
   int PausePriority, PauseLifetime;
   int PauseKeyHandling;
diff -ruN vdr-1.7.24/device.c vdr-1.7.25/device.c
--- vdr-1.7.24/device.c	2012-02-15 14:15:19.000000000 +0100
+++ vdr-1.7.25/device.c	2012-03-03 12:43:05.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: device.c 2.49 2012/02/15 13:15:19 kls Exp $
+ * $Id: device.c 2.55 2012/03/03 11:43:05 kls Exp $
  */
 
 #include "device.h"
@@ -59,9 +59,6 @@
 
 // --- cDevice ---------------------------------------------------------------
 
-// The default priority for non-primary devices:
-#define DEFAULTPRIORITY  -1
-
 // The minimum number of unknown PS1 packets to consider this a "pre 1.3.19 private stream":
 #define MIN_PRE_1_3_19_PRIVATESTREAM 10
 
@@ -229,7 +226,7 @@
   return NumProvidedSystems;
 }
 
-cDevice *cDevice::GetDevice(const cChannel *Channel, int Priority, bool LiveView)
+cDevice *cDevice::GetDevice(const cChannel *Channel, int Priority, bool LiveView, bool Query)
 {
   cDevice *AvoidDevice = avoidDevice;
   avoidDevice = NULL;
@@ -269,7 +266,7 @@
           if (NumUsableSlots && !CamSlots.Get(j)->Assign(device[i], true))
              continue; // CAM slot can't be used with this device
           bool ndr;
-          if (device[i]->ProvidesChannel(Channel, (LiveView && device[i]->IsPrimaryDevice()) ? Setup.PrimaryLimit : Priority, &ndr)) { // this device is basicly able to do the job
+          if (device[i]->ProvidesChannel(Channel, Priority, &ndr)) { // this device is basicly able to do the job
              if (NumUsableSlots && device[i]->CamSlot() && device[i]->CamSlot() != CamSlots.Get(j))
                 ndr = true; // using a different CAM slot requires detaching receivers
              // Put together an integer number that reflects the "impact" using
@@ -284,8 +281,8 @@
              imp <<= 1; imp |= device[i]->Receiving();                                                               // avoid devices that are receiving
              imp <<= 4; imp |= GetClippedNumProvidedSystems(4, device[i]) - 1;                                       // avoid cards which support multiple delivery systems
              imp <<= 1; imp |= device[i] == cTransferControl::ReceiverDevice();                                      // avoid the Transfer Mode receiver device
-             imp <<= 8; imp |= min(max(device[i]->Priority() + MAXPRIORITY, 0), 0xFF);                               // use the device with the lowest priority (+MAXPRIORITY to assure that values -99..99 can be used)
-             imp <<= 8; imp |= min(max((NumUsableSlots ? SlotPriority[j] : 0) + MAXPRIORITY, 0), 0xFF);              // use the CAM slot with the lowest priority (+MAXPRIORITY to assure that values -99..99 can be used)
+             imp <<= 8; imp |= device[i]->Priority() - IDLEPRIORITY;                                                 // use the device with the lowest priority (- IDLEPRIORITY to assure that values -100..99 can be used)
+             imp <<= 8; imp |= (NumUsableSlots ? SlotPriority[j] : IDLEPRIORITY) - IDLEPRIORITY;                     // use the CAM slot with the lowest priority (- IDLEPRIORITY to assure that values -100..99 can be used)
              imp <<= 1; imp |= ndr;                                                                                  // avoid devices if we need to detach existing receivers
              imp <<= 1; imp |= NumUsableSlots ? 0 : device[i]->HasCi();                                              // avoid cards with Common Interface for FTA channels
              imp <<= 1; imp |= device[i]->AvoidRecording();                                                          // avoid SD full featured cards
@@ -304,7 +301,7 @@
       if (!NumUsableSlots)
          break; // no CAM necessary, so just one loop over the devices
       }
-  if (d) {
+  if (d && !Query) {
      if (NeedsDetachReceivers)
         d->DetachAllReceivers();
      if (s) {
@@ -655,7 +652,7 @@
 
 bool cDevice::MaySwitchTransponder(const cChannel *Channel) const
 {
-  return time(NULL) > occupiedTimeout && !Receiving(true) && !(pidHandles[ptAudio].pid || pidHandles[ptVideo].pid || pidHandles[ptDolby].pid);
+  return time(NULL) > occupiedTimeout && !Receiving() && !(pidHandles[ptAudio].pid || pidHandles[ptVideo].pid || pidHandles[ptDolby].pid);
 }
 
 bool cDevice::SwitchChannel(const cChannel *Channel, bool LiveView)
@@ -690,7 +687,7 @@
      cChannel *channel;
      while ((channel = Channels.GetByNumber(n, Direction)) != NULL) {
            // try only channels which are currently available
-           if (GetDevice(channel, 0, true))
+           if (GetDevice(channel, LIVEPRIORITY, true, true))
               break;
            n = channel->Number() + Direction;
            }
@@ -711,13 +708,15 @@
 
 eSetChannelResult cDevice::SetChannel(const cChannel *Channel, bool LiveView)
 {
+  cStatus::MsgChannelSwitch(this, 0);
+
   if (LiveView) {
      StopReplay();
      DELETENULL(liveSubtitle);
      DELETENULL(dvbSubtitleConverter);
      }
 
-  cDevice *Device = (LiveView && IsPrimaryDevice()) ? GetDevice(Channel, 0, LiveView) : this;
+  cDevice *Device = (LiveView && IsPrimaryDevice()) ? GetDevice(Channel, LIVEPRIORITY, true) : this;
 
   bool NeedsTransferMode = Device != this;
 
@@ -728,7 +727,6 @@
 
   if (NeedsTransferMode) {
      if (Device && CanReplay()) {
-        cStatus::MsgChannelSwitch(this, 0); // only report status if we are actually going to switch the channel
         if (Device->SetChannel(Channel, false) == scrOk) // calling SetChannel() directly, not SwitchChannel()!
            cControl::Launch(new cTransferControl(Device, Channel));
         else
@@ -739,7 +737,6 @@
      }
   else {
      Channels.Lock(false);
-     cStatus::MsgChannelSwitch(this, 0); // only report status if we are actually going to switch the channel
      // Stop section handling:
      if (sectionHandler) {
         sectionHandler->SetStatus(false);
@@ -880,7 +877,7 @@
 void cDevice::SetVolume(int Volume, bool Absolute)
 {
   int OldVolume = volume;
-  volume = min(max(Absolute ? Volume : volume + Volume, 0), MAXVOLUME);
+  volume = constrain(Absolute ? Volume : volume + Volume, 0, MAXVOLUME);
   SetVolumeDevice(volume);
   Absolute |= mute;
   cStatus::MsgSetVolume(Absolute ? volume : volume - OldVolume, Absolute);
@@ -1049,7 +1046,8 @@
      int LanguagePreference = INT_MAX; // higher than the maximum possible value
      for (int i = ttSubtitleFirst; i <= ttSubtitleLast; i++) {
          const tTrackId *TrackId = GetTrack(eTrackType(i));
-         if (TrackId && TrackId->id && I18nIsPreferredLanguage(Setup.SubtitleLanguages, TrackId->language, LanguagePreference))
+         if (TrackId && TrackId->id && (I18nIsPreferredLanguage(Setup.SubtitleLanguages, TrackId->language, LanguagePreference) ||
+            (i == ttSubtitleFirst + 8 && !*TrackId->language && LanguagePreference == INT_MAX))) // compatibility mode for old subtitles plugin
             PreferredTrack = eTrackType(i);
          }
      // Make sure we're set to an available subtitle track:
@@ -1495,7 +1493,9 @@
 
 int cDevice::Priority(void) const
 {
-  int priority = IsPrimaryDevice() ? Setup.PrimaryLimit - 1 : DEFAULTPRIORITY;
+  int priority = IDLEPRIORITY;
+  if (IsPrimaryDevice() && !Replaying() && ActualDevice() == PrimaryDevice())
+     priority = TRANSFERPRIORITY; // we use the same value here, no matter whether it's actual Transfer Mode or real live viewing
   cMutexLock MutexLock(&mutexReceiver);
   for (int i = 0; i < MAXRECEIVERS; i++) {
       if (receiver[i])
@@ -1509,11 +1509,11 @@
   return true;
 }
 
-bool cDevice::Receiving(bool CheckAny) const
+bool cDevice::Receiving(bool Dummy) const
 {
   cMutexLock MutexLock(&mutexReceiver);
   for (int i = 0; i < MAXRECEIVERS; i++) {
-      if (receiver[i] && (CheckAny || receiver[i]->priority >= 0)) // cReceiver with priority < 0 doesn't count
+      if (receiver[i])
          return true;
       }
   return false;
diff -ruN vdr-1.7.24/device.h vdr-1.7.25/device.h
--- vdr-1.7.24/device.h	2012-02-14 15:42:42.000000000 +0100
+++ vdr-1.7.25/device.h	2012-03-02 11:23:13.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: device.h 2.33 2012/02/14 14:42:42 kls Exp $
+ * $Id: device.h 2.36 2012/03/02 10:23:13 kls Exp $
  */
 
 #ifndef __DEVICE_H
@@ -139,7 +139,7 @@
          ///< Gets the device with the given Index.
          ///< \param Index must be in the range 0..numDevices-1.
          ///< \return A pointer to the device, or NULL if the Index was invalid.
-  static cDevice *GetDevice(const cChannel *Channel, int Priority, bool LiveView);
+  static cDevice *GetDevice(const cChannel *Channel, int Priority, bool LiveView, bool Query = false);
          ///< Returns a device that is able to receive the given Channel at the
          ///< given Priority, with the least impact on active recordings and
          ///< live viewing. The LiveView parameter tells whether the device will
@@ -153,6 +153,10 @@
          ///< after detaching any receivers because the channel can't be decrypted,
          ///< this device/CAM combination will be skipped in the next call to
          ///< GetDevice().
+         ///< If Query is true, no actual CAM assignments or receiver detachments will
+         ///< be done, so that this function can be called without any side effects
+         ///< in order to just determine whether a device is available for the given
+         ///< Channel.
          ///< See also ProvidesChannel().
   static void SetAvoidDevice(cDevice *Device) { avoidDevice = Device; }
          ///< Sets the given Device to be temporarily avoided in the next call to
@@ -235,12 +239,11 @@
   virtual bool ProvidesTransponderExclusively(const cChannel *Channel) const;
          ///< Returns true if this is the only device that is able to provide
          ///< the given channel's transponder.
-  virtual bool ProvidesChannel(const cChannel *Channel, int Priority = -1, bool *NeedsDetachReceivers = NULL) const;
+  virtual bool ProvidesChannel(const cChannel *Channel, int Priority = IDLEPRIORITY, bool *NeedsDetachReceivers = NULL) const;
          ///< Returns true if this device can provide the given channel.
-         ///< In case the device has cReceivers attached to it or it is the primary
-         ///< device, Priority is used to decide whether the caller's request can
-         ///< be honored.
-         ///< The special Priority value -1 will tell the caller whether this device
+         ///< In case the device has cReceivers attached to it, Priority is used to
+         ///< decide whether the caller's request can be honored.
+         ///< The special Priority value IDLEPRIORITY will tell the caller whether this device
          ///< is principally able to provide the given Channel, regardless of any
          ///< attached cReceivers.
          ///< If NeedsDetachReceivers is given, the resulting value in it will tell the
@@ -719,9 +722,8 @@
   cReceiver *receiver[MAXRECEIVERS];
 public:
   int Priority(void) const;
-      ///< Returns the priority of the current receiving session (0..MAXPRIORITY),
-      ///< or -1 if no receiver is currently active. The primary device will
-      ///< always return at least Setup.PrimaryLimit-1.
+      ///< Returns the priority of the current receiving session (-MAXPRIORITY..MAXPRIORITY),
+      ///< or IDLEPRIORITY if no receiver is currently active.
 protected:
   virtual bool OpenDvr(void);
       ///< Opens the DVR of this device and prepares it to deliver a Transport
@@ -736,8 +738,8 @@
       ///< false in case of a non recoverable error, otherwise it returns true,
       ///< even if Data is NULL.
 public:
-  bool Receiving(bool CheckAny = false) const;
-       ///< Returns true if we are currently receiving.
+  bool Receiving(bool Dummy = false) const;
+       ///< Returns true if we are currently receiving. The parameter has no meaning (for backwards compatibility only).
   bool AttachReceiver(cReceiver *Receiver);
        ///< Attaches the given receiver to this device.
   void Detach(cReceiver *Receiver);
